#include <cstdlib>
#include <iostream>
#include <cmath>

#define PI 3.14159265358979323846
#define N 11 
using namespace std;

int main(int argc, char *argv[])
{    
    double x_n[N] = {6.5, 1, 5, -2.5 , 3.3 , 1.414 , 1.414 , 3.3 , -2.5 , 5, 1};
    double ans_n[N]; 
    int Q = N / 2;  
    /////////// reset array ///////////
    for(int i=0; i<N ;i++){
    	ans_n[i] = 0; 
	}
    /////////// reset array ///////////
    
    /////////// DCT ///////////
    for(int i=0; i<N ;i++){
    	for(int j=0; j<=Q ;j++){
    		if(j == 0 || (j == Q && (N % 2) ==0)) 
    			ans_n[i] += x_n[j]*cos(2*PI*i*j/N);
    		else
    			ans_n[i] += 2*x_n[j]*cos(2*PI*i*j/N);
		}
	}
    /////////// DCT ///////////
    
    /////////// output /////////// 
    for(int i=0; i<N ;i++){
    	cout << "x_n[" << i << "]= " << x_n[i] << endl;
	}
	cout << endl;
    for(int i=0; i<N ;i++){
    	cout << "ans[" << i << "]= " << ans_n[i] << endl;
	}
	/////////// output ///////////
	
    system("PAUSE");
    return 0;
}
